﻿package com.asgamer.armkra 
{
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.Event;
	
	public class Engine extends MovieClip
	{
		
		private var numStars:int = 80;
		public static var enemyList:Array = new Array();
		private var ourShip:Ship;
		
		private var scoreHUD:ScoreHUD;
		
		public function Engine() : void
		{
			ourShip = new Ship(stage);
			ourShip.x = stage.stageWidth / 2;
			ourShip.y = stage.stageHeight / 2;
			ourShip.addEventListener("hit", shipHit, false, 0, true);
			stage.addChild(ourShip);
			
			
			scoreHUD = new ScoreHUD(stage);
			stage.addChild(scoreHUD);
			
			for (var i:int = 0; i < numStars; i++)
			{
				stage.addChildAt(new Star(stage), stage.getChildIndex(ourShip));
			}
			
			addEventListener(Event.ENTER_FRAME, loop, false, 0, true);
			
		}
		
		private function loop(e:Event) : void
		{
			if (Math.floor(Math.random() * 90) == 5)
			{
				var enemy:Stinger = new Stinger(stage, ourShip);
				
				enemy.addEventListener(Event.REMOVED_FROM_STAGE, removeEnemy, false, 0, true);
				enemy.addEventListener("killed", enemyKilled, false, 0, true);
				enemyList.push(enemy);
				stage.addChild(enemy);
			}	
		}
		
		private function enemyKilled(e:Event)
		{
			scoreHUD.updateKills(1);
			scoreHUD.updateScore(e.currentTarget.points);			
		}
		
		private function removeEnemy(e:Event)
		{
			enemyList.splice(enemyList.indexOf(e.currentTarget), 1);
		}
		
		private function shipHit(e:Event)
		{
			scoreHUD.updateHits(1);
		}
	
		
	}
	
}